/*
** explode.c
**
** Reverse engineered version of PKWARE Data Compression Library.
**
** PKWARE Data Compression Library (R)
** Copyright 1989-1996 PKWARE Inc.  All Rights Reserved
** Patent No. 5,051,745
** PKWARE Data Compression Library Reg. U.S. Pat. and Tm. Off.
** Version 1.11
**
** Source:
** Diablo v1.04 for MacOS (PowerPC)
** Copyright 1996-1998 Blizzard Entertainment.
**
** Reverse engineering by z80. August 28, 1998.
*/

#include "dclib.h"

static unsigned short __explode_1(unsigned char *buf);
static unsigned short __explode_2(unsigned char *buf);
static unsigned short __explode_3(unsigned char *buf, unsigned short result);
static unsigned short __explode_4(unsigned char *buf, unsigned long flag);
static void __explode_5(unsigned short count, unsigned char *buf_1, const unsigned char *table, unsigned char *buf_2);
static void __explode_6(unsigned char *buf, const unsigned char *table);
static void __explode_7(unsigned char *buf, const unsigned char *table, unsigned long count);

unsigned long explode(read_data_proc read_data, write_data_proc write_data,unsigned char *work_buff, void *param)
{
   unsigned long result;
   unsigned short read_result;
 const unsigned char *table = dcl_table;

 *((unsigned long *) (work_buff + 0x16)) = (unsigned long) read_data;
 *((unsigned long *) (work_buff + 0x1A)) = (unsigned long) write_data;
 *((void **) (work_buff + 0x12)) = param;
 *((unsigned short *) (work_buff + 0x0E)) = 0x0800;
 read_result = read_data(work_buff + 0x2222, 0x0800, param);
 if (read_result == DCL_ERROR_4)
 {
  result = DCL_ERROR_3;
 }
 else
 {
  unsigned short flag_0 = *(work_buff + 0x2222),
    flag_1 = *(work_buff + 0x2223),
    flag_2 = *(work_buff + 0x2224);

  *((unsigned short *) (work_buff + 0x02)) = flag_0;
  *((unsigned short *) (work_buff + 0x06)) = flag_1;
  *((unsigned short *) (work_buff + 0x0A)) = flag_2;
  *((unsigned short *) (work_buff + 0x0C)) = 0x00;
  *((unsigned short *) (work_buff + 0x0E)) = 0x03;
  *((unsigned short *) (work_buff + 0x10)) = read_result;
  if ((flag_1 < 0x04) || (flag_1 > 0x06))
  {
   result = DCL_ERROR_1;
  }
  else
  {
    *((unsigned short *) (work_buff + 0x08)) = (unsigned short) (0x0000FFFFL >> (0x0010 - flag_1));
    if (flag_0 > 0x01)
    {
     result = DCL_ERROR_2;
    }
    else
    {
     if (flag_0)
     {
      __explode_7(work_buff + 0x2FA2, table + 0x00D0, 0x0100);
      __explode_6(work_buff, table + 0x01D0);
     }
     __explode_7(work_buff + 0x30E2, table + 0x00B0, 0x0010);
     __explode_5(0x0010, work_buff + 0x30E2, table + 0x00C0, work_buff + 0x2B22);
     __explode_7(work_buff + 0x30F2, table + 0x0080, 0x0010);
     __explode_7(work_buff + 0x3102, table + 0x0090, 0x0020);
     __explode_7(work_buff + 0x30A2, table, 0x0040);
     __explode_5(0x0040, work_buff + 0x30A2, table + 0x0040, work_buff + 0x2A22);
     if (__explode_1(work_buff) != 0x0306)
     {
      result = DCL_NO_ERROR;
     }
     else
     {
      result = DCL_ERROR_4;
     }
    }
  }
 } return result;
}

unsigned short __explode_1(unsigned char *buf)
{
 unsigned long   result, temp;
 unsigned char   *s, *d;
 write_data_proc *write_data;
 void   *param;

 *((unsigned short *) (buf + 0x04)) = 0x1000;
 while (result = __explode_2(buf), (unsigned short) result < 0x0305)
 {
  if ((unsigned short) result < 0x0100)
  {
   temp = *((unsigned short *) (buf + 0x04));
   *((unsigned short *) (buf + 0x04)) = (unsigned short) (temp + 0x01);
   *(buf + temp + 0x1E) =(unsigned char) result;
  }
  else
  {
   result -= 0x00FE;
   s = (unsigned char *) __explode_3(buf, (unsigned short) result);
   if (!s)
   {
    result = 0x0306;
    break;
   }
   else
   {
    temp = *((unsigned short *) (buf + 0x04));
    d = temp + 0x1E + buf;
    *((unsigned short *) (buf + 0x04)) =(unsigned short) (temp + result);
    s = (unsigned char *)((unsigned long)d - (unsigned long)s);
    do
    {
     result--;
     *(d++) = *(s++);
    } while (result);
   }
  }
  if (*((unsigned short *) (buf + 4)) >= 0x2000)
  {
   result = 0x1000;
   write_data = (write_data_proc *) *((unsigned long *) (buf + 0x1A));
   param = (void *) *((unsigned long *) (buf + 0x12));
   write_data(buf + 0x101E, 0x1000, param);
   __explode_7(buf + 0x001E, buf + 0x101E, *((unsigned short *) (buf + 0x04)) - 0x1000);
   *((unsigned short *) (buf + 0x04)) -= 0x1000;
  }
 }
 write_data = (write_data_proc *) *((unsigned long *) (buf + 0x1A));
 param = (void *) *((unsigned long *) (buf + 0x12));
 write_data(buf + 0x101E, (unsigned short)(*((unsigned short *) (buf + 0x04)) - 0x1000), param);
 return (unsigned short) result;
}

unsigned short __explode_2(unsigned char *buf)
{
 unsigned long result, flag, flag_1;

 if (*((unsigned short *) (buf + 0x0A)) & 0x01)
 {
  if (__explode_4(buf, 0x01)) return 0x0306;
  result = *(buf + ((unsigned char) *((unsigned short *) (buf + 0x0A))) + 0x2B22);
  if (__explode_4(buf, *(buf + ((unsigned short) result) + 0x30E2))) return 0x0306;
  flag = *(buf + ((unsigned short) result) + 0x30F2);
  if (flag)
  {
   flag_1 = (*((unsigned short *) (buf + 0x0A))) & ((0x01 << flag) - 0x01);
   if (__explode_4(buf, flag))
   {
    if ((((unsigned short) result) + ((unsigned short) flag_1)) != 0x010E) return 0x0306;
   } result = *((unsigned short *) (buf + (((unsigned short) result) << 0x01) + 0x3102)) + flag_1;
  } result += 0x0100;
 }
 else
 {
  if (__explode_4(buf, 0x01)) return 0x0306;
  if (!*((unsigned short *) (buf + 0x02)))
  {
   result = (unsigned char) *((unsigned short *) (buf + 0x0A));
   if (__explode_4(buf, 0x08)) return 0x0306;
  }
  else
  {
   flag = *((unsigned short *) (buf + 0x0A));
   if ((unsigned char) flag)
   {
    result = *(buf + ((unsigned char) flag) + 0x2C22);
    if (((unsigned short) result) == 0x00FF)
    {
     if (flag & 0x003F)
     {
      if (__explode_4(buf, 0x04)) return 0x0306;
      result = *(buf + ((unsigned char) *((unsigned short *) (buf + 0x0A))) + 0x2D22);
     }
     else
     {
      if (__explode_4(buf, 0x06)) return 0x0306;
      result = *(buf + ((*((unsigned short *) (buf + 0x0A))) & 0x007F) + 0x2E22);
     }
    }
   }
   else
   {
    if (__explode_4(buf, 0x08)) return 0x0306;
    result = *(buf + ((unsigned char) *((unsigned short *) (buf + 0x0A))) + 0x2EA2);
   }
   flag = *(buf + ((unsigned short) result) + 0x2FA2);
   if (__explode_4(buf, flag)) return 0x0306;
  }
 } return (unsigned short)result;
}

unsigned short __explode_3(unsigned char *buf, unsigned short flag)
{
 unsigned long result, flag_1;

 result = *(buf + ((unsigned char) *((unsigned short *) (buf + 0x0A))) + 0x2A22);
 if (__explode_4(buf, *(buf + ((unsigned short) result) + 0x30A2))) return 0x00;
 if (((unsigned short) flag) == 0x02)
 {
  result <<= 0x02;
  result |= *((unsigned short *) (buf + 0x0A)) & 0x03;
  if (__explode_4(buf, 0x02)) return 0x00;
 }
 else
 {
  flag_1 = *((unsigned short *) (buf + 0x06));
  result <<= flag_1;
  result |= *((unsigned short *) (buf + 0x08)) & *((unsigned short *) (buf + 0x0A));
  if (__explode_4(buf, flag_1)) return 0x00;
 } return (unsigned short) (result + 0x01);
}

unsigned short __explode_4(unsigned char *buf, unsigned long flag)
{
 unsigned long   result;
 unsigned short   read_result;
 read_data_proc *read_data = (read_data_proc *) *((unsigned long *) (buf + 0x16));
 void   *param = (void *) *((unsigned long *) (buf + 0x12));

 result = *((unsigned short *) (buf + 0x0C));
 if ((unsigned short) flag <= result)
 {
  *((unsigned short *) (buf + 0x0A)) >>= flag;
  *((unsigned short *) (buf + 0x0C)) -= (unsigned short)flag;
  result = 0x00;
 }
 else
 {
  *((unsigned short *) (buf + 0x0A)) >>= result;
  result = *((unsigned short *) (buf + 0x0E));
  if (result == *((unsigned short *) (buf + 0x10)))
  {
   *((unsigned short *) (buf + 0x0E)) = 0x0800;
   read_result = read_data(buf + 0x2222, 0x0800, param);
   *((unsigned short *) (buf + 0x10)) = read_result;
   if (!read_result) return 0x01;
   *((unsigned short *) (buf + 0x0E)) = 0x00;
  }
  result = *((unsigned short *) (buf + 0x0E)) + 0x2222;
  *((unsigned short *) (buf + 0x0A)) |= *(buf + result) << 0x08;
  *((unsigned short *) (buf + 0x0E)) += 0x01;
  *((unsigned short *) (buf + 0x0A)) >>= flag - *((unsigned short *) (buf + 0x0C));
  *((unsigned short *) (buf + 0x0C)) = (unsigned short)(0x08 - (flag - *((unsigned short *) (buf + 0x0C))));

  result = 0x00;
 } return (unsigned short) result;
}

void __explode_5(unsigned short count, unsigned char *buf_1, const unsigned char *table, unsigned char *buf_2)
{
 short i = (short)(count - 1);
 unsigned long idx_1, idx_2;

 for (; i >= 0; i--)
 {
  idx_1 = *(table + i);
  idx_2 = 0x01 << *(buf_1 + i);
  for (;;)
  {
   *(buf_2 + (unsigned short) idx_1) = (unsigned char) i;
   idx_1 += idx_2;
   if ((unsigned short) idx_1 >= 0x0100) break;
  }
 }
}

void __explode_6(unsigned char *buf, const unsigned char *table)
{
 short i;
 unsigned long idx_1, idx_2;

 for (i = 0x00FF; i >= 0; i--)
 {
  idx_1 = *(buf + i + 0x2FA2);
  if (idx_1 <= 0x08 )
  {
   idx_2 = *((unsigned short *) (table + (i << 0x01)));
   idx_1 = 0x01 << idx_1;
   do
   {
    *(buf + idx_2 + 0x2C22) =(unsigned char) i;
    idx_2 += idx_1;
   } while ((unsigned short) idx_2 < 0x0100);
  }
  else
  {
   idx_2 = *((unsigned short *) (table + (i << 0x01)));
   if ((unsigned char) idx_2)
   {

    *(buf + (unsigned char) idx_2 + 0x2C22) = 0xFF;
    if (*((unsigned short *) (table + (i << 0x01))) & 0x003F)
    {
     *(buf + i + 0x2FA2) -= 0x04;
     idx_1 = 0x01 << *(buf + i + 0x2FA2);
     idx_2 = *((unsigned short *) (table + (i << 0x01))) >> 0x04;
     do
     {
      *(buf + idx_2 + 0x2D22) =(unsigned char) i;
      idx_2 += idx_1;
     } while ((unsigned short) idx_2 < 0x0100);
    }
    else
    {
     *(buf + i + 0x2FA2) -= 0x06;
     idx_1 = 0x01 << *(buf + i + 0x2FA2);
     idx_2 = *((unsigned short *) (table + (i << 0x01))) >> 0x06;
     do
     {
      *(buf + idx_2 + 0x2E22) = (unsigned char)i;
      idx_2 += idx_1;
     } while ((unsigned short) idx_2 < 0x0080);
    }
   }
   else
   {
    *(buf + i + 0x2FA2) -= 0x08;
    idx_1 = 0x01 << *(buf + i + 0x2FA2);
    idx_2 = *((unsigned short *) (table + (i << 0x01))) >> 0x08;
    do
    {
     *(buf + idx_2 + 0x2EA2) = (unsigned char)i;
     idx_2 += idx_1;
    } while ((unsigned short) idx_2 < 0x0100);
   }
  }
 }
}

void __explode_7(unsigned char *buf, const unsigned char *table, unsigned long count)
{
 unsigned long half_count = count >> 0x02;
 unsigned char *buf_end;

 if (half_count)
 {
  buf_end = buf + (half_count << 0x02);
  do
  {
   *((unsigned long *) buf) = *((unsigned long *) table);
   buf += 4;
   table += 4;
  } while (buf < buf_end);
 }
 switch (count - (half_count << 0x02))
 {
  case 3:
   *(buf++) = *(table++);

  case 2:
   *(buf++) = *(table++);

  case 1:
   *buf = *table;

  default:
   break;
 }
}
